#include "basicwindow.h"
#include "userutilities.h"
#include "processingani.h"
#include "infowindow.h"

class InfoOverviewWindow: public BasicWindow
{
	public:
		InfoOverviewWindow();
		~InfoOverviewWindow();
	
	protected:
		GtkWidget		*contentBox,
						*closeButton,
						*editButton,
						*updateButton,
						*titleLabel;	
	
		ProcessingAni	*updateAnimation;
	
	
		GtkWidget	*createWindowContent();
		void		destroyWindowContent();
	
	
		GtkWidget	*createContentBox();
		GtkWidget	*createButtonbar();
		
		GtkWidget	*createInterestsLabel(GList *iList, gchar* iName);
	
		void		setDoUpdate(gboolean doUpdate);
	
		gboolean	eventCallback(gint command, gint lastResult, gpointer info);
		void		escPressed();
	
	
		static void cb_updateButtonClicked(InfoOverviewWindow *self);
		static void cb_closeButtonClicked(InfoOverviewWindow *self);
		static void cb_editButtonClicked(InfoOverviewWindow *self);
		static void cb_homepageButtonClicked(GtkWidget *btn, InfoOverviewWindow *self);
};
