/***************************************************************************
 *            randomchat.h
 *
 *  Thu Jun 22 22:01:12 2006
 *  Copyright  2006  User
 *  Email
 ****************************************************************************/

#ifndef _RANDOMCHAT_H
#define _RANDOMCHAT_H

#include "basicwindow.h"
#include "processingani.h"
#include "icons.h"
#include "userutilities.h"

class SelectRandomChatGroupWindow: public BasicWindow
{
	public:
		SelectRandomChatGroupWindow();
		~SelectRandomChatGroupWindow();
	
		gchar		*introText,
					*titleText;
		GtkWidget	*notebook;
	
	protected:
		GtkListStore	*groupsStore;
		GtkWidget		*groupsView;	
	
		GtkWidget	*createWindowContent();
		
		void 		destroyWindowContent();
		virtual GtkWidget	*createButtonbar();
		virtual	void	okayButtonClicked();
	
	
		static void cb_okayButtonClicked(SelectRandomChatGroupWindow* self);
};


class StartRandomChatWindow: public SelectRandomChatGroupWindow
{
	public:
		StartRandomChatWindow();
		~StartRandomChatWindow();
	
	private:
		ProcessingAni			*sendAni;	
		GtkWidget				*findButton,
								*aliasLabel;
		IMUserDaemon			*newUser;
		IMAutoResponseManager	*arMan;
	
		GtkWidget	*createButtonbar();
		void		destroyWindowContent();
	
		gboolean eventCallback(gint command, gint lastResult, gpointer info);
		void	 createUserFoundWindow(IMUserDaemon	*user);
	
		void	okayButtonClicked();
	
	
	// Callbacks
	static void cb_findButtonClicked(StartRandomChatWindow* self);
	static void cb_cancelButtonClicked(StartRandomChatWindow* self);
	static void cb_showUserInfoButtonClicked(StartRandomChatWindow* self);
	static void cb_startChatInfoButtonClicked(StartRandomChatWindow* self);
	static void cb_addPermanentlyButtonClicked(StartRandomChatWindow* self);
	
	static gboolean cb_foundUserEventCallback(UserEventType type, gint command, gint lastResult, gpointer info, StartRandomChatWindow* self);
	static gboolean cb_fetchedAREventCallback(UserEventType type, gint command, gint lastResult, gpointer info, StartRandomChatWindow* self);

};

#endif /* _RANDOMCHAT_H */
