#include "infooverviewwindow.h"

InfoOverviewWindow::InfoOverviewWindow()
{
	wType = UE_USERINFO;
}


InfoOverviewWindow::~InfoOverviewWindow()
{
	delete manager;	
}



GtkWidget	*InfoOverviewWindow::createWindowContent()
{
	GtkWidget	*notebook,
				*vbox2,
				*mainVBox,
				*label1,
				*label2,
				*vbox1,
				*img,
				*introHBox,
				*scrolled;
	
	gchar		*fstr;
	

	// create the labels
	fstr = g_strdup_printf("<b>%s %s</b>", "User Information for", manager->info->alias);
	titleLabel = gtk_label_new(fstr);
	gtk_label_set_use_markup(GTK_LABEL(titleLabel), TRUE);
	gtk_misc_set_alignment(GTK_MISC(titleLabel), 0, 0);
	g_free(fstr);
	
	fstr = g_strdup_printf("<small>%s</small>", tr("Below is a list of all information that is provided by the user."));	
	label2 = gtk_label_new(fstr);
	gtk_widget_set_size_request(label2, 270, -1);
	gtk_label_set_use_markup(GTK_LABEL(label2), TRUE);
	gtk_label_set_line_wrap(GTK_LABEL(label2), TRUE);
	gtk_misc_set_alignment(GTK_MISC(label2), 0, 0);
	g_free(fstr);
	
	vbox1 = gtk_vbox_new(FALSE, 5);
	gtk_box_pack_start(GTK_BOX(vbox1), titleLabel, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox1), label2, TRUE, TRUE, 0);
	
	// create the picture
	fstr = g_strdup_printf("%sicqnd/info.png", SHARE_DIR);
	img = gtk_image_new_from_file(fstr);
	g_free(fstr);
	
	introHBox = gtk_hbox_new(FALSE, 5);
	gtk_box_pack_start(GTK_BOX(introHBox), img, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(introHBox), vbox1, FALSE, TRUE, 0);
	
	
	
	contentBox = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(contentBox), createContentBox(), TRUE, TRUE, 0);
	
	
	scrolled = gtk_scrolled_window_new(NULL, NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(scrolled), GTK_SHADOW_NONE);
	
	gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrolled), contentBox);
	
	vbox2 = gtk_vbox_new(FALSE, 10);
	gtk_container_set_border_width(GTK_CONTAINER(vbox2), 5);
	gtk_box_pack_start(GTK_BOX(vbox2), introHBox, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox2), scrolled, TRUE, TRUE, 0);
	
	notebook = gtk_notebook_new();
	gtk_notebook_set_show_tabs(GTK_NOTEBOOK(notebook), FALSE);
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), vbox2, NULL);
	
	// add everything into a big vbox + button bar
	mainVBox = gtk_vbox_new(FALSE, 10);
	gtk_container_set_border_width(GTK_CONTAINER(mainVBox), 10);
	gtk_box_pack_start(GTK_BOX(mainVBox), notebook, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(mainVBox), createButtonbar(), FALSE, TRUE, 0);
	
	fstr = g_strdup_printf(tr("Information for %s"), manager->info->alias);
	setWindowTitle(fstr);
	g_free(fstr);
	
	setWindowSize(400, 400);
	
	return mainVBox;
}



GtkWidget *InfoOverviewWindow::createButtonbar()
{
	GtkWidget	*hbox;
	
	
	hbox = gtk_hbox_new(FALSE, 3);
	
	updateButton = gtk_button_new_from_stock(GTK_STOCK_REFRESH);
	g_signal_connect_swapped(updateButton, "clicked", G_CALLBACK(cb_updateButtonClicked), this);
	editButton = u_createTextStockImageButton(tr("Edit locally"), GTK_STOCK_EDIT);
	g_signal_connect_swapped(editButton, "clicked", G_CALLBACK(cb_editButtonClicked), this);
	closeButton = gtk_button_new_from_stock(GTK_STOCK_CLOSE);
	g_signal_connect_swapped(closeButton, "clicked", G_CALLBACK(cb_closeButtonClicked), this);
	
	updateAnimation = new ProcessingAni();
	updateAnimation->setupAnimation(i_getIcons()->images.searchingAni, 22, 22);

	
	gtk_box_pack_start(GTK_BOX(hbox), updateAnimation->widget, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), updateButton, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), editButton, FALSE, TRUE, 0);
	gtk_box_pack_end(GTK_BOX(hbox), closeButton, FALSE, TRUE, 0);
	
	
	
	return hbox;
}



#define IOW_CREATE_SECTION(caption)			\
	if (sectionCnt->str && *sectionCnt->str)	\
	{											\
		fstr = g_strdup_printf("<b>%s</b>", caption);	\
		label = gtk_label_new(fstr);					\
		gtk_label_set_use_markup(GTK_LABEL(label), TRUE); \
		gtk_misc_set_alignment(GTK_MISC(label), 0, 0);	\
		g_free(fstr);									\
														\
		label2 = gtk_label_new(sectionCnt->str);			\
		gtk_label_set_use_markup(GTK_LABEL(label2), TRUE);	\
		gtk_misc_set_alignment(GTK_MISC(label2), 0, 0);	\
		alignment = gtk_alignment_new(0, 0, 1, 1);		\
		gtk_alignment_set_padding(GTK_ALIGNMENT(alignment), 0, 5, 20, 0);	\
		gtk_container_add(GTK_CONTAINER(alignment), label2);			\
		gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);			\
		gtk_box_pack_start(GTK_BOX(vbox), alignment, FALSE, TRUE, 0);	\
	}																	\
																		\
	g_string_free(sectionCnt, TRUE);									\
	sectionCnt = g_string_new(NULL);

#define IOW_ADD_MAN_INFO(infoname)							\
	if (manager->info->infoname && *manager->info->infoname)	\
		g_string_append_printf(infoCnt, "%s ", manager->info->infoname);
	
	
	
#define IOW_ADD_MAN_INT_INFO(infoname, toInterpret)					\
	if (manager->info->infoname && manager->info->infoname != 65535)\
	{																\
		fstr = g_strdup_printf(toInterpret, manager->info->infoname);		\
		infoCnt = g_string_append(infoCnt, fstr);					\
		g_free(fstr);												\
	}
	
	
#define IOW_FINISH_INFO(infoname)							\
	if (infoCnt->str && *infoCnt->str)						\
	{														\
		fstr = g_strdup_printf("<b>%s:</b> %s\n", infoname, infoCnt->str);	\
		sectionCnt = g_string_append(sectionCnt, fstr);	\
		g_free(fstr);										\
	} else													\
		g_string_free(infoCnt, TRUE);						\
															\
	infoCnt = g_string_new(NULL);							\
	
GtkWidget	*InfoOverviewWindow::createContentBox()
{
	GtkWidget	*vbox,
				*vbox2,
				*label,
				*label2,
				*ivbox,
				*ihbox,
				*hbox2,
				*alignment,
				*sectionVBox,
				*interest1,
				*interest2,
				*interest3,
				*personalSiteButton,
				*workSiteButton;
	gchar		*fstr;
	GString		*sectionCnt,
				*infoCnt;
	
	vbox = gtk_vbox_new(FALSE, 6);
	gtk_container_set_border_width(GTK_CONTAINER(vbox), 2);
	
	sectionCnt = g_string_new(NULL);
	infoCnt = g_string_new(NULL);
	
	
	// General User information
	IOW_ADD_MAN_INFO(firstname);
	IOW_ADD_MAN_INFO(lastname);
	IOW_FINISH_INFO(tr("Name"));
	
	IOW_ADD_MAN_INFO(alias);
	IOW_FINISH_INFO(tr("Alias"));
	
	IOW_ADD_MAN_INFO(licqID);
	IOW_FINISH_INFO(tr("User ID"));
	
	infoCnt = g_string_append(infoCnt, uu_getStatusDescription(manager->info->status));
	IOW_FINISH_INFO(tr("Status"));
	
	IOW_ADD_MAN_INFO(formattedIP);
	IOW_FINISH_INFO(tr("IP"));
	
	IOW_CREATE_SECTION(tr("General Info"));
	
	
	// Address information
	IOW_ADD_MAN_INFO(home.address);
	IOW_FINISH_INFO(tr("Street"));
	
	IOW_ADD_MAN_INFO(home.zip);
	IOW_ADD_MAN_INFO(home.city);
	IOW_FINISH_INFO(tr("City"));
	
	IOW_ADD_MAN_INFO(home.state);
	IOW_FINISH_INFO(tr("State"));
	
	if (manager->info->home.country)
		infoCnt = g_string_append(infoCnt, gCountries[manager->info->home.country].szName);
	IOW_FINISH_INFO(tr("Country"));
	
	IOW_CREATE_SECTION(tr("Address"));
	
	
	
	// Contact information
	IOW_ADD_MAN_INFO(home.phone);
	IOW_FINISH_INFO(tr("Phone"));
	
	IOW_ADD_MAN_INFO(home.fax);
	IOW_FINISH_INFO(tr("Fax"));
	
	IOW_ADD_MAN_INFO(home.mobile);
	IOW_FINISH_INFO(tr("Mobile"));
	
	IOW_ADD_MAN_INFO(email1);
	IOW_FINISH_INFO(tr("Primary E-Mail"));
	
	IOW_ADD_MAN_INFO(email2);
	IOW_FINISH_INFO(tr("Secondary E-Mail"));
	
	IOW_ADD_MAN_INFO(email3);
	IOW_FINISH_INFO(tr("Old E-Mail"));
	
	IOW_CREATE_SECTION(tr("Contact"));
	
	
	// Personal information
	IOW_ADD_MAN_INT_INFO(age, "%d");
	IOW_FINISH_INFO(tr("Age"));
	
	IOW_ADD_MAN_INT_INFO(birthday.month, "%d - ");
	IOW_ADD_MAN_INT_INFO(birthday.day, "%d - ");
	IOW_ADD_MAN_INT_INFO(birthday.year, "%d");
	IOW_FINISH_INFO(tr("Birthday"));
		
	if (manager->info->gender)
	{
		if (manager->info->gender == 1)
			infoCnt = g_string_append(infoCnt, tr("Female"));
		else
			infoCnt = g_string_append(infoCnt, tr("Male"));
	}
	IOW_FINISH_INFO(tr("Gender"));
	
	if (manager->info->language1)
	{
		infoCnt = g_string_append(infoCnt, gLanguages[manager->info->language1].szName);

		if (manager->info->language2 || manager->info->language3)
			infoCnt = g_string_append(infoCnt, ", ");
	}
	if (manager->info->language2)
	{
		infoCnt = g_string_append(infoCnt, gLanguages[manager->info->language2].szName);
		if (manager->info->language3)
			infoCnt = g_string_append(infoCnt, ", ");
	}
	if (manager->info->language3)
		infoCnt = g_string_append(infoCnt, gLanguages[manager->info->language3].szName);
	IOW_FINISH_INFO(tr("Languages"));
	
	IOW_CREATE_SECTION(tr("Personal Information"));
	
	
	// Homepage
	if (manager->info->website && *manager->info->website)
	{
		personalSiteButton = u_createTextStockImageButton(manager->info->website, ICON_URL);
		g_object_set_data(G_OBJECT(personalSiteButton), "icqnd-psite", manager->info->website);
		gtk_button_set_relief(GTK_BUTTON(personalSiteButton), GTK_RELIEF_NONE);
		g_signal_connect(personalSiteButton, "clicked", G_CALLBACK(this->cb_homepageButtonClicked), this);
		
		fstr = g_strdup_printf("<b>%s</b>", tr("Homepage"));
		label = gtk_label_new(fstr);					
		gtk_label_set_use_markup(GTK_LABEL(label), TRUE);
		gtk_misc_set_alignment(GTK_MISC(label), 0, 0);
		g_free(fstr);

		fstr = g_strdup_printf("<b>%s</b>: ", tr("Address"));
		label2 = gtk_label_new(fstr);
		g_free(fstr);
		gtk_label_set_use_markup(GTK_LABEL(label2), TRUE);
		gtk_misc_set_alignment(GTK_MISC(label2), 0, 0.5);
		
		hbox2 = gtk_hbox_new(FALSE, 0);
		gtk_box_pack_start(GTK_BOX(hbox2), label2, FALSE, FALSE, 0);
		gtk_box_pack_start(GTK_BOX(hbox2), personalSiteButton, FALSE, TRUE, 0);
		
		alignment = gtk_alignment_new(0, 0, 1, 1);
		gtk_alignment_set_padding(GTK_ALIGNMENT(alignment), 0, 5, 20, 0);
		gtk_container_add(GTK_CONTAINER(alignment), hbox2);
		gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);
		gtk_box_pack_start(GTK_BOX(vbox), alignment, FALSE, TRUE, 0);
		
	}	
	
	// Interests info
	ivbox = gtk_vbox_new(FALSE, 2);
	
	interest1 = createInterestsLabel(manager->info->interests, tr("Interests"));
	interest2 = createInterestsLabel(manager->info->organizations, tr("Organizations"));
	interest3 = createInterestsLabel(manager->info->background, tr("Backgrounds"));
	
	if (interest1 || interest2 || interest3)
	{
		fstr = g_strdup_printf("<b>%s</b>", tr("Interests / More Info"));
		label = gtk_label_new(fstr);					
		gtk_label_set_use_markup(GTK_LABEL(label), TRUE); 
		gtk_misc_set_alignment(GTK_MISC(label), 0, 0);	
		g_free(fstr);									
		
		ivbox = gtk_vbox_new(FALSE, 2);
		if (interest1)
			gtk_box_pack_start(GTK_BOX(ivbox), interest1, FALSE, TRUE, 0);
		if (interest2)
			gtk_box_pack_start(GTK_BOX(ivbox), interest2, FALSE, TRUE, 0);
		if (interest3)
			gtk_box_pack_start(GTK_BOX(ivbox), interest3, FALSE, TRUE, 0);
				
		alignment = gtk_alignment_new(0, 0, 1, 1);
		gtk_alignment_set_padding(GTK_ALIGNMENT(alignment), 0, 8, 20, 0);
		gtk_container_add(GTK_CONTAINER(alignment), ivbox);
		gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);
		gtk_box_pack_start(GTK_BOX(vbox), alignment, FALSE, TRUE, 0);
	}
		
	
	// Work info
	IOW_ADD_MAN_INFO(company.name);
	IOW_FINISH_INFO(tr("Name"));
	
	IOW_ADD_MAN_INFO(company.department);
	IOW_FINISH_INFO(tr("Department"));
	
	IOW_ADD_MAN_INFO(company.position);
	IOW_FINISH_INFO(tr("Position"));
	
	IOW_ADD_MAN_INFO(company.address);
	IOW_FINISH_INFO(tr("Street"));
	
	IOW_ADD_MAN_INFO(company.zip);
	IOW_ADD_MAN_INFO(company.city);
	IOW_FINISH_INFO(tr("City"));
	
	IOW_ADD_MAN_INFO(company.state);
	IOW_FINISH_INFO(tr("State"));
	
	if (manager->info->company.country)
		infoCnt = g_string_append(infoCnt, gCountries[manager->info->company.country].szName);
	IOW_FINISH_INFO(tr("Country"));
	
	IOW_ADD_MAN_INFO(company.phone);
	IOW_FINISH_INFO(tr("Phone"));
	
	IOW_ADD_MAN_INFO(company.fax);
	IOW_FINISH_INFO(tr("Fax"));
	
	if ((sectionCnt->str && *sectionCnt->str) || 
		(manager->info->company.website && *manager->info->company.website))
	{											
		fstr = g_strdup_printf("<b>%s</b>", tr("Work Information"));
		label = gtk_label_new(fstr);				
		gtk_label_set_use_markup(GTK_LABEL(label), TRUE);
		gtk_misc_set_alignment(GTK_MISC(label), 0, 0);
		g_free(fstr);
		
		vbox2 = gtk_vbox_new(FALSE, 2);		
		
		// add work info if present
		if (sectionCnt->str && *sectionCnt->str)
		{			
			// cut the last "\n"
			if (sectionCnt->str[strlen(sectionCnt->str)-2] == '\n')
				sectionCnt->str[strlen(sectionCnt->str)-2] = '\0';
			
			label2 = gtk_label_new(sectionCnt->str);
			gtk_label_set_use_markup(GTK_LABEL(label2), TRUE);
			gtk_misc_set_alignment(GTK_MISC(label2), 0, 0);
			
			gtk_box_pack_start(GTK_BOX(vbox2), label2, FALSE, FALSE, 0);
		}
			
		// add homepage if present
		if (manager->info->company.website && *manager->info->company.website)
		{
			workSiteButton = u_createTextStockImageButton(manager->info->company.website, ICON_URL);
			g_object_set_data(G_OBJECT(workSiteButton), "icqnd-psite", manager->info->company.website);
			gtk_button_set_relief(GTK_BUTTON(workSiteButton), GTK_RELIEF_NONE);
			g_signal_connect(G_OBJECT(workSiteButton), "clicked", G_CALLBACK(this->cb_homepageButtonClicked), this);
		
			fstr = g_strdup_printf("<b>%s</b>: ", tr("Website"));
			label2 = gtk_label_new(fstr);
			g_free(fstr);
			gtk_label_set_use_markup(GTK_LABEL(label2), TRUE);
			gtk_misc_set_alignment(GTK_MISC(label2), 0, 0.5);
		
			hbox2 = gtk_hbox_new(FALSE, 0);
			gtk_box_pack_start(GTK_BOX(hbox2), label2, FALSE, FALSE, 0);
			gtk_box_pack_start(GTK_BOX(hbox2), workSiteButton, FALSE, TRUE, 0);	

			gtk_box_pack_start(GTK_BOX(vbox2), hbox2, FALSE, TRUE, 0);			
		}
		
		alignment = gtk_alignment_new(0, 0, 1, 1);
		gtk_alignment_set_padding(GTK_ALIGNMENT(alignment), 0, 5, 20, 0);
		gtk_container_add(GTK_CONTAINER(alignment), vbox2);
		gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);
		gtk_box_pack_start(GTK_BOX(vbox), alignment, FALSE, TRUE, 0);
	}																
																	
	g_string_free(sectionCnt, TRUE);								
	sectionCnt = g_string_new(NULL);
	
	
	
	// About info
	IOW_ADD_MAN_INFO(about);
	sectionCnt = infoCnt;
	IOW_CREATE_SECTION(tr("About this user"));
	gtk_label_set_line_wrap(GTK_LABEL(label2), TRUE);
	
	
	return vbox;
}



GtkWidget	*InfoOverviewWindow::createInterestsLabel(GList *iList, gchar *iName)
{
	GtkWidget		*hbox,
					*vbox,
					*vbox2,
					*alignment,
					*label;
	GList			*searchc,
					*searche;
	IMUserListInfo	*info;
	gchar			*fstr;
	GString			*infoCnt;
	
	
	if (!iList)
		return NULL;

	
	vbox = gtk_vbox_new(FALSE, 2);
	
	for (searchc = iList; searchc; searchc = searchc->next)
	{
		info = (IMUserListInfo*)searchc->data;
		

		
		infoCnt = g_string_new(NULL);
		
		for (searche = info->entries; searche; searche = searche->next)
			g_string_append_printf(infoCnt, "%s, ", (gchar*)searche->data);
		
		// remove the last ", "
		if (strlen(infoCnt->str)>0)
			infoCnt = g_string_truncate(infoCnt, strlen(infoCnt->str)-2);
		
		// prepend the info category name
		fstr = g_strdup_printf("<i>%s:</i> ", info->headline);
		infoCnt = g_string_prepend(infoCnt, fstr);
		g_free(fstr);
		
		label = gtk_label_new(infoCnt->str);
		gtk_label_set_use_markup(GTK_LABEL(label), TRUE);
		gtk_label_set_line_wrap(GTK_LABEL(label), TRUE);
		gtk_misc_set_alignment(GTK_MISC(label), 0, 0);
		
		gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, TRUE, 0);
		
		g_string_free(infoCnt, TRUE);
	}
	
	// Create the general category name
	fstr = g_strdup_printf("<b>%s: </b>", iName);
	label = gtk_label_new(fstr);
	gtk_label_set_use_markup(GTK_LABEL(label), TRUE);
	gtk_misc_set_alignment(GTK_MISC(label), 0, 0);
	
	// add an alignment around the vbox
	alignment = gtk_alignment_new(0, 0, 1, 1);
	gtk_alignment_set_padding(GTK_ALIGNMENT(alignment), 0, 0, 10, 0);
	gtk_container_add(GTK_CONTAINER(alignment), vbox);
	
	
	// add everything into a vbox
	vbox2 = gtk_vbox_new(FALSE, 2);
	gtk_box_pack_start(GTK_BOX(vbox2), label, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox2), alignment, FALSE, TRUE, 0);
	
	return vbox2;
}



void InfoOverviewWindow::destroyWindowContent()
{
	
}



void InfoOverviewWindow::setDoUpdate(gboolean doUpdate)
{
	gtk_widget_set_sensitive(updateButton, !doUpdate);
	gtk_widget_set_sensitive(editButton, !doUpdate);
	gtk_widget_set_sensitive(contentBox, !doUpdate);
	
	if (doUpdate)
		updateAnimation->play();
	else
		updateAnimation->stop();
	
	if (doUpdate)
		gtk_button_set_label(GTK_BUTTON(closeButton), GTK_STOCK_CANCEL);
	else
		gtk_button_set_label(GTK_BUTTON(closeButton), GTK_STOCK_CLOSE);
	
	gtk_button_set_use_stock(GTK_BUTTON(closeButton), TRUE);	
}



gboolean InfoOverviewWindow::eventCallback(gint command, gint lastResult, gpointer info)
{
	switch(command)
	{
		case UC_EVENT_FINISHED:

			setDoUpdate(FALSE);
		
			if (lastResult != EVENT_RESULT_ACKED && lastResult != EVENT_RESULT_SUCCESS)
				uu_showSendErrorMessage(tr("Could not update"), 
										tr("Updating of the user failed"), 
										lastResult, 
										manager->info->status);
			else
			if (((IMUserUpdateManager*)manager)->sendUpdateStep == 0)
			{
				gtk_container_forall(GTK_CONTAINER(contentBox), (GtkCallback)gtk_widget_destroy, NULL);
				gtk_box_pack_start(GTK_BOX(contentBox), createContentBox(), TRUE, TRUE, 0);
				gtk_widget_show_all(contentBox);
			} 
			break; 
	}
	
	return TRUE;
	
}



void InfoOverviewWindow::escPressed()
{
	cb_closeButtonClicked(this);
}



void InfoOverviewWindow::cb_updateButtonClicked(InfoOverviewWindow *self)
{
	self->setDoUpdate(TRUE);

	((IMUserUpdateManager*)self->manager)->updateUserInfo(NULL);
}


void InfoOverviewWindow::cb_closeButtonClicked(InfoOverviewWindow *self)
{
	if (GTK_WIDGET_IS_SENSITIVE(self->contentBox))
	{
		self->destroyWindow();
		delete self;
	}
	else
	{
		self->setDoUpdate(FALSE);
		self->manager->cancelInitatedEvent();
	}
}


void InfoOverviewWindow::cb_editButtonClicked(InfoOverviewWindow *self)
{
	self->manager->callUser(UE_EDITUSERINFO, NULL);
	
	self->destroyWindow();
	delete self;
}



void InfoOverviewWindow::cb_homepageButtonClicked(GtkWidget *btn, InfoOverviewWindow *self)
{
	gchar	*address;
	
	address = (gchar*)g_object_get_data(G_OBJECT(btn), "icqnd-psite");
	
	uu_openURL(address);
}
