/***************************************************************************
 *            passwordwindow.cpp
 *
 *  Mon Jan 29 00:45:06 2007
 *  Copyright  2007  User
 *  Email
 ****************************************************************************/

#include "passwordwindow.h"
#include "utilities.h"


PasswordErrorWindow::PasswordErrorWindow(IMOwnerDaemon *owner)
{	
	GtkWidget	*label,
				*icon,
				*hbox,
				*hbox2,
				*vbox,
				*pwLabel;
	gchar		*fstr;
	gint		res;
	
	
	// Create the headline
	fstr = g_strdup_printf(tr("The combination of user name and password for your account %s doesn't match. Please correct your password and press \"Okay\"."), owner->info->alias);
	
	label = gtk_label_new(fstr);
	g_free(fstr);
	
	gtk_label_set_line_wrap(GTK_LABEL(label), TRUE);
	gtk_misc_set_alignment(GTK_MISC(label), 0, 0);
	
	
	icon = gtk_image_new_from_stock(GTK_STOCK_DIALOG_ERROR, GTK_ICON_SIZE_DIALOG);
	gtk_misc_set_alignment(GTK_MISC(icon), 0.5f, 0.0f);
   
	hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), icon, FALSE, FALSE, 5);
	gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 5);
	
	
	// Create the password entry
	pwLabel = gtk_label_new(tr("New password:"));
	pwEntry = gtk_entry_new();
	gtk_entry_set_visibility(GTK_ENTRY(pwEntry), FALSE);
	
	hbox2 = gtk_hbox_new(FALSE, 2);
	gtk_box_pack_start(GTK_BOX(hbox2), pwLabel, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox2), pwEntry, TRUE, TRUE, 0);
	
	
	// add everything into a vbox
	vbox = gtk_vbox_new(FALSE, 10);
	gtk_container_set_border_width(GTK_CONTAINER(vbox), 10);
	gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), hbox2, FALSE, TRUE, 0);
	
	
	dialog = gtk_dialog_new_with_buttons (tr("Wrong password"),
										  NULL,
										  GTK_DIALOG_DESTROY_WITH_PARENT,
										  GTK_STOCK_OK,
										  GTK_RESPONSE_YES,
										  GTK_STOCK_CANCEL,
										  GTK_RESPONSE_NO,
										  NULL);	
								
	// g_signal_connect(dialog, "response", G_CALLBACK(gtk_widget_destroy), NULL);								


	gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialog)->vbox), vbox);


	gdk_threads_enter();

	gtk_widget_show_all(dialog);	
	
	res = gtk_dialog_run (GTK_DIALOG(dialog));
	
	gdk_threads_leave();	
	
	if (res == GTK_RESPONSE_YES) 
	{
		owner->setPassword((gchar*)gtk_entry_get_text(GTK_ENTRY(pwEntry)));
		owner->setStatus(BUDDY_STATUS_ONLINE);
	}
	
	printf("Jawoll\n");
	
	gtk_widget_destroy(dialog);
}



PasswordErrorWindow::~PasswordErrorWindow()
{
	
}







PasswordSetWindow::PasswordSetWindow(IMOwnerDaemon *owner) 
{
	u_showInfoDialog(GTK_MESSAGE_INFO, "Hold on", "Work is in progress");
}



PasswordSetWindow::~PasswordSetWindow()
{
	
}
